ADDMUL - Editorial

PROBLEM LINK:

Practice
Contest

Author: Devendra Agarwal
Tester: Mugurel Ionut Andreica
Editorialist: Lalit Kundu

DIFFICULTY:

Medium

PREREQUISITES:

segment tree, lazy propagation, basic maths

PROBLEM:

Given array A of N size and M operations of type:

  1. Add v to all elements in a range.
  2. Multiply v to all elements in a range.
  3. Reset all items to v in a range.
  4. Report sum in a range.

QUICK EXPLANATION:

================
Build a segment tree, where at each node we store \textrm{sum} and variables \textrm{mul} and \textrm{add}, which denotes that the lazy update A_i \leftarrow \textrm{mul}*A_i + \textrm{add} needs to be applied. If required, we update the current nodeā€™s sum and variables and propagate the laziness down the tree. Also, an multiplication update v at a node can be summarised as \textrm{mul} \leftarrow \textrm{mul}*v and \textrm{add} \leftarrow \textrm{add}*v and also addition update v at a node can be written as \textrm{add} \leftarrow \textrm{add} + v. Set operation with value v can be written as \textrm{mul} \leftarrow 0 and \textrm{add} \leftarrow v.

EXPLANATION:

================

BASIC SEGMENT TREE STUFF

I assume you know how segment trees and lazy propagation work and the basic concepts behind them like time complexity, nodes, intervals. First, Iā€™ll introduce some terminology Iā€™m going to use.

  • Node: Itā€™s one of the nodes in the segment tree, it represents a contiguous interval of the array A.
  • Interval of a node is the actual range covered by the node.
  • Answer of a node is defined the actual value needed for interval queries. Here, for example, we need sum of values in the range.

Letā€™s think step by step here.

  • For range query problems, try to see if segment tree can be used.
  • When does segment tree work? When you can merge two contiguous intervals(i.e nodes) to get answer of merged interval(node) in sublinear time. If complexity of merging is O(K), then complexity for each operation can be worst case O(\textrm{log N}*K). For example, when we talk about range minimum function, we can get minimum value of merged interval by taking minimum of answers of two individual intervals.
  • Also, for range updates you need to use lazy propagation. What does lazy propagation require to work? It requires that for an interval if we have multiple update operations, we can calculate the answer for that interval without actually updating every element in that interval. For example, if we are trying to find range minimum and range updation query is increase all elements by value v, then our new minimum is sum of existing minimum with v. Here also, we should be able to do this operation in sublinear time because it contributes to the factor of updations and queries.

Letā€™s see how we use above two points to find here a solution using segment trees. Letā€™s see the query part first: query is range sum, so merging two intervals is easy, just take the individual sums.

THE LAZY PROPAGATION SOLUTION

Now, letā€™s see how we can handle all updations in such a way that we can find answer for an interval without actually updating the whole interval. We are going to store some data about the updations being done at that interval node and process it to find the answer. What could be this data? How do we find out? We need to observe what kind of operations we are doing. After some certain updations, our A_i could be transformed to something like ((A_i*v_1 + v_2)*v_3 + v_4 + v_5)*v_6 + v_7, where v_1 to v_7 are values of range multiplication or range addition. Now, we can store all these values v_1 to v_7 at our node, but we might have to do O(\textrm{number of queries}) operations at each node, which is not really sublinear. We need to find a compact notation at each node interval.

Now, thing worth noting here is that A_i has been transformed to a linear function of A_i i.e. something of form (\textrm{mul}*A_i + \textrm{add}). Now, letā€™s say I make one more multiplication range update v, whatā€™s the new value of A_i. Itā€™s (\textrm{mul}*v*A_i + \textrm{add}*v). So, we update \textrm{mul} *= v and \textrm{add} *= v at our node. Similarly, if we make a sum update with value v, the new value of A_i is (\textrm{mul}*A_i + \textrm{add} + v), so we update \textrm{add} += v. For setting all elements to v, we can just make one multiplication with 0 and then addition with value v.

So, if this interval is in range L to R, for interval sum, we need \sum_{i=L}^{R}(\textrm{mul}*A_i + \textrm{add}) which we can write as (R-L+1)*\textrm{add} + \textrm{mul}*\sum_{i=L}^{R}A_i. So, we have to store sum of original A_i and R and L(basically size) and two variables \textrm{mul} and \textrm{add} at each node. Now, to make things easier we can just directly store the \textrm{sum} of a node(i.e. sum of all elements in that interval) instead of storing sum of original A_i. Then, for each range multiplication update or range addition update, we also update this \textrm{sum} along with the variables \textrm{mul} and \textrm{add}.

Also, as we do we in lazy propagation, we propagate the laziness to the children of a node, if we need to query a children of a lazy node. In this problem, we can individually propagate variables \textrm{mul} and \textrm{add}. So, if at a node \textrm{mul} \ne 1, then we can say that this node is multiplication lazy and if required, weā€™ll propagate this variable down to the children of this node. Similarly, if at a node \textrm{add} \ne 0, we can say that this node is addition lazy and propagate this laziness down to its children.

COMPLEXITY:

For building the segment tree we need O(N \textrm{log} N) and each query is O(\textrm{log} N), so total complexity is O(N \textrm{log} N + Q \textrm{log} N).

PROBLEMS TO SOLVE:

QSET
SPOJ HORRIBLE
FNCS
MSTICK
ANUSAR
FRBSUM
Sherlock and Unique Substrings

AUTHORā€™S, TESTERā€™S SOLUTIONS:

setter
tester

21 Likes

Is it possible to solve this problem using BIT and are there any other approaches for solving first 3 sub-tasks other than segment tree ?

1 Like

[1] Code you tell me test case where my solution failed used the same concept but could not figure out where i have made a mistake


  [1]: http://www.codechef.com/viewsolution/7421703

I think you have made a mistake in this sentence where you write

Set operation with value v can be
written as mulā†1 and addā†0.

Later on you write For setting all elements to v, we can just make one multiplication with 0 and then addition with value v.
So I guess mul, should be set to 0 and add to v?

1 Like

This was an amazing problem! Took a lot of tinkering and checking. And obviously required some common sense :slight_smile:

4 Likes

i did all the things specified aboveā€¦buy creating an add[]and multiply[]arrayā€¦and calculating the sum with lazy propagation still i was getting TLE all the timeā€¦i dont know where i was wrongā€¦here is my codeā€¦
http://www.codechef.com/viewsolution/7474886

pls can someone tell me whats wrongā€¦it will be a great helpā€¦

Great problem. Really felt nice to solve this one. Thanks to the author.

1 Like

How (if) can we use ā€˜heavy light decompositionā€™ to solve this problem?

+1 to the editorialist, explanation is great, and mentioning the similar problems for practice, I really appreciate his efforts and Thanks!!

2 Likes

the time limit has been set dumbly , I implemented everything as in editorial but then also got tle , CodeChef: Practical coding for everyone

@terminated I think time limit was well set :slight_smile:

Hello all,

Is there some way of accessing the test cases for this problem statement? The contest judge declared that my solution was segfaulting. I generated test cases in the order as suggested in the problem statement which ran successfully in my machine, so I would like to check with the actual test cases where the segfaulting is occurring.

Thanks
Sudharshan

What it is not mentioned is how you really do the propagation,a key element in this problem. This was my biggest problem. Here the priority of operations is important. You cannot do the propagation how you wantā€¦
So if you propagate from a node to right node,you know that the updates from node where made later( because of propagation itself).
Letā€™s say sum in right node is X(after we make all updates with its vals , add and mul).Now we come with information from node,knowing it was made later,it comes like that:(X+a1+a2+a3)a4a5+a6 ā€¦ So mul and add from right node become mul*=mulnode and add=add*mulnode+addnode
That observation was important to me and I spent some time thinking ā€¦
If any of you found a easier way,please let me know! :slight_smile:

1 Like

Can anyone properly explain how to propagate the add and mul values to the left and right node? I think that point is a bit unclear in the editorial.

1 Like

Thanks a lot for the similar problems list :slight_smile:

What is the problem with this solution?

#include
#include <stdio.h>

using namespace std;

int main() {

long n, q, m = 1000000007L;
cin>>n>>q;
long a[n];
for(long i=0;i<n;i++)    {
    cin>>a[i];
}
long t, x,y, v;

for(long i=0;i<q;i++)    {
    cin>>t>>x>>y;
    x--;
    y--;
    
    if(t==1)    {
        cin>>v;
        for(long j=x;j<=y;j++)   {
            a[j]+=v;
            a[j]%=m;
        }
    }
    else if(t==2)   {
         cin>>v;
        for(long j=x;j<=y;j++)   {
            a[j]*=v;
            a[j]%=m;
        }
    }
    else if(t==3)   {
         cin>>v;
        for(long j=x;j<=y;j++)   {
            a[j]=v;
           // a[j]%=m;
        }
    }
    else if(t==4)   {
        int sum = 0;
        for(long j=x;j<=y;j++)   {
            sum+=a[j];
            sum%=m;
        }
        cout<<sum;
    }
}


return 0;

}

@shivam312 the only problem is that it is very slow. Suppose if we have 1000 queries and in each query we have L=1 and R=1000 than we u can see that nit will take a lot of time in doing computation. So thats why u get TLE.

Amazing problem! I did it after reading the editorial. It took a while; but it really reinforced my understanding of segment trees. You can view my solution here if interested.

I am getting WA
https://www.codechef.com/viewsolution/7492057

I am also getting WA on similar spoj problem SPOJ.com - Problem HORRIBLE
My spoj solution id Sphere Online Judge (SPOJ) - Submit a solution
I am not able to figure out why i am getting WA in both problems. Please help me out?

Can someone tell me what is wrong with my solution.I did as told in the Editorial.

https://www.codechef.com/viewsolution/7492127